/* KalamosP : pour ecrire en grec ancien polytonal v 1.1
 copyleft GNU GPL v3
 J F Ferrier, 07 2018
 jfftux83@tuxfamily.org
 version 1.0
 
 for Processing V2 and V3
 
 texte des remplacements entré à partir d'un fichier
 change.txt ,  a placer dans sous dossier /data
 
 */

import g4p_controls.*;
import java.awt.Font;

GTextArea txa1, txa2;
GButton btnValider;

// variables globales
String[] paragraphs  ;
String startTextA = "";
String chaineEntree1 = "";
String[] toReplace1 ;

int taillePolice = 20;
int widWind = 800;
int heigWind = 600;



public void setup()

{
  size(800, 600);
  G4P.setGlobalColorScheme(GCScheme.BLUE_SCHEME);

  // texte d' entr'ee : fichier change.txt
  toReplace1 = loadStrings("change.txt");

  // 1ere ligne = Largeur fenetre
  widWind =  int(toReplace1[0]);
  // 2e ligne = hauteur fenetre
  heigWind =  int(toReplace1[1]);
  surface.setLocation(0, 0);
  surface.setSize(widWind, heigWind);

  // 3e ligne = taillePolice
  taillePolice = int(toReplace1[2]);

  // calculs tailles zones textes et bouton
  // xdep, ydep, taille x, taille y
  int tx1 = width / 2 - 10 ;
  int ty1 = height - 70 ;

  int xdep2 =  width / 2 + 10 ;
  int tx2 = width / 2 - 20 ;
  int ty2 = height - 70 ;

  int xDepBout = width/2 -60 ;
  int yDepBout = height - 55 ;

  // xdep, ydep, taille x, taille y
  txa1 = new GTextArea(this, 5, 10, tx1, ty1, G4P.SCROLLBARS_VERTICAL_ONLY);
  txa1.tag = "txa1";

  txa1.setFont(new Font("Arial", Font.PLAIN, taillePolice));

  txa1.setPromptText("Entrer Texte...");
  txa1.setFocus(true);

  txa2 = new GTextArea(this, xdep2, 10, tx2, ty2, G4P.SCROLLBARS_VERTICAL_ONLY);
  txa2.tag = "txa2";
  txa2.setFont(new Font("Arial", Font.PLAIN, taillePolice));

  btnValider = new GButton(this, xDepBout, yDepBout, 120, 50, "=>>");

  btnValider.setFont(new Font("Arial", Font.PLAIN, taillePolice));
} // end setup



public void draw() {
  background(50, 200, 50);
  stroke(1);
  strokeWeight(2);
} // end draw



void handleButtonEvents(GButton button, GEvent event) {
  if (button == btnValider && event == GEvent.CLICKED) {

    traitement1();
  }// end if
}// end handleButtonEvent



void traitement1()
{
  // lecture chaine
  chaineEntree1 = txa1.getText();

  String cht = replaceWords(chaineEntree1, toReplace1);

  // ecriture chaine
  txa2.setText(cht);
} // end traitement1



// fonction replaceWords
// utilisation : println(replaceWords(someText1, toReplace));
String replaceWords(String textR, String[] toReplace)
{
  textR += " ";
  //  n = 3   car 3  1eres chaines = 3 nombres
  for (int n = 3; n < toReplace.length-1; n += 2)
  {
    // pas fonction replaceAll qui traite les regex !
    textR = textR.replace(toReplace[n], toReplace[n+1]);
  } // end for n

  return textR;
} // end fonct replaceWords


// end program
